#include "exportfuncs.h"

HSP_ANSIC_FUNC g_funcs[FUNCS_MAX];

void initfuncs(){
	// ctype
	g_funcs[CTYPE_START + 0] = hsp_isalnum;
	g_funcs[CTYPE_START + 1] = hsp_isalpha;
	g_funcs[CTYPE_START + 2] = hsp_isctrl;
	g_funcs[CTYPE_START + 3] = hsp_isdigit;
	g_funcs[CTYPE_START + 4] = hsp_isgraph;
	g_funcs[CTYPE_START + 5] = hsp_islower;
	g_funcs[CTYPE_START + 6] = hsp_isprint;
	g_funcs[CTYPE_START + 7] = hsp_ispunct;
	g_funcs[CTYPE_START + 8] = hsp_isspace;
	g_funcs[CTYPE_START + 9] = hsp_isupper;
	g_funcs[CTYPE_START + 10] = hsp_isxdigit;
	g_funcs[CTYPE_START + 11] = hsp_tolower;
	g_funcs[CTYPE_START + 12] = hsp_toupper;

	// stdio
	g_funcs[STDIO_START + 0x00] = hsp_fopen;
	g_funcs[STDIO_START + 0x01] = hsp_fclose;
	g_funcs[STDIO_START + 0x02] = hsp_freopen;

	g_funcs[STDIO_START + 0x10] = hsp_fgetc;
	g_funcs[STDIO_START + 0x11] = hsp_getchar;
	g_funcs[STDIO_START + 0x12] = hsp_fgets;
	g_funcs[STDIO_START + 0x13] = hsp_gets;
	g_funcs[STDIO_START + 0x14] = hsp_sscanf;
	g_funcs[STDIO_START + 0x15] = hsp_fscanf;
	g_funcs[STDIO_START + 0x16] = hsp_scanf;

	g_funcs[STDIO_START + 0x20] = hsp_fputc;
	g_funcs[STDIO_START + 0x21] = hsp_putchar;
	g_funcs[STDIO_START + 0x22] = hsp_fputs;
	g_funcs[STDIO_START + 0x23] = hsp_puts;
	g_funcs[STDIO_START + 0x24] = hsp_sprintf;
	g_funcs[STDIO_START + 0x25] = hsp_fprintf;
	g_funcs[STDIO_START + 0x26] = hsp_printf;

	g_funcs[STDIO_START + 0x30] = hsp_fread;
	g_funcs[STDIO_START + 0x31] = hsp_fwrite;

	g_funcs[STDIO_START + 0x50] = hsp_clearerr;
	g_funcs[STDIO_START + 0x51] = hsp_feof;
	g_funcs[STDIO_START + 0x52] = hsp_ferror;
	g_funcs[STDIO_START + 0x53] = hsp_fflush;
	g_funcs[STDIO_START + 0x54] = hsp_fgetpos;
	g_funcs[STDIO_START + 0x55] = hsp_fseek;
	g_funcs[STDIO_START + 0x56] = hsp_fsetpos;
	g_funcs[STDIO_START + 0x57] = hsp_ftell;
	g_funcs[STDIO_START + 0x58] = hsp_perror;
	g_funcs[STDIO_START + 0x59] = hsp_remove;
	g_funcs[STDIO_START + 0x60] = hsp_rename;
	g_funcs[STDIO_START + 0x61] = hsp_rewind;
	//g_funcs[STDIO_START + 0x62] = hsp_setbuf;
	//g_funcs[STDIO_START + 0x63] = hsp_setvbuf;
	g_funcs[STDIO_START + 0x64] = hsp_tmpfile;
	g_funcs[STDIO_START + 0x65] = hsp_tmpnam;
	g_funcs[STDIO_START + 0x66] = hsp_ungetc;
	//g_funcs[STDIO_START + 0x67] = hsp_vfprintf;
	//g_funcs[STDIO_START + 0x68] = hsp_vprintf;
	//g_funcs[STDIO_START + 0x69] = hsp_vsprintf;

	//string
	g_funcs[STRING_START + 0x00] = hsp_memcpy;
	g_funcs[STRING_START + 0x01] = hsp_memmove;
	g_funcs[STRING_START + 0x02] = hsp_strcpy;
	g_funcs[STRING_START + 0x03] = hsp_strncpy;
	g_funcs[STRING_START + 0x04] = hsp_strcat;
	g_funcs[STRING_START + 0x05] = hsp_strncat;
	g_funcs[STRING_START + 0x06] = hsp_memcmp;
	g_funcs[STRING_START + 0x07] = hsp_strcmp;
	g_funcs[STRING_START + 0x08] = hsp_strcoll;
	g_funcs[STRING_START + 0x09] = hsp_strncomp;
	g_funcs[STRING_START + 0x0A] = hsp_strxfrm;
	g_funcs[STRING_START + 0x0B] = hsp_memchr;
	g_funcs[STRING_START + 0x0C] = hsp_strchr;
	g_funcs[STRING_START + 0x0D] = hsp_strcspn;
	g_funcs[STRING_START + 0x0E] = hsp_strrchr;
	g_funcs[STRING_START + 0x0F] = hsp_strrchr;
	g_funcs[STRING_START + 0x10] = hsp_strspn;
	g_funcs[STRING_START + 0x11] = hsp_strstr;
	g_funcs[STRING_START + 0x12] = hsp_strtok;
	g_funcs[STRING_START + 0x13] = hsp_memset;
	g_funcs[STRING_START + 0x14] = hsp_strerror;

	//math
	g_funcs[MATH_START + 0xF0] = hsp_hugevalfunc;

	g_funcs[MATH_START + 0x00] = hsp_acos;
	g_funcs[MATH_START + 0x01] = hsp_asin;
	g_funcs[MATH_START + 0x02] = hsp_atan;
	g_funcs[MATH_START + 0x03] = hsp_atan2;
	g_funcs[MATH_START + 0x04] = hsp_cosh;
	g_funcs[MATH_START + 0x05] = hsp_sinh;
	g_funcs[MATH_START + 0x06] = hsp_tanh;
	g_funcs[MATH_START + 0x07] = hsp_frexp;
	g_funcs[MATH_START + 0x08] = hsp_ldexp;
	g_funcs[MATH_START + 0x09] = hsp_log10;
	g_funcs[MATH_START + 0x0A] = hsp_modf;
	g_funcs[MATH_START + 0x0B] = hsp_pow;
	g_funcs[MATH_START + 0x0C] = hsp_ceil;
	g_funcs[MATH_START + 0x0D] = hsp_floor;
	g_funcs[MATH_START + 0x0E] = hsp_fmod;

	//time
}
